#!/bin/bash
############################################################################################################################
# Novell Inc.
# 1800 South Novell Place
# Provo, UT 84606-6194
# Script Name:         add_uniquedomainid_all.sh
# Description:           This script will add uniquedomianid to all objects.
#  			                              
# %Version:             1.0
# %Creating Date:    Sat May 18 14:33:19 MDT 2013
# %Created by:        Rance Burker - Novell Technical Services
# %Contact Information:	If you have any comments/requests/issues, please contact Rance Burker at rance@novell.com  
###########################################################################################################################

clear
export LDAPCONF=/etc/opt/novell/xad/openldap/ldap.conf
echo -e "This script will search for objects without a uniquedomainid"
echo -e "and add uniquedomianid to all reported objects within the domain."

# Set the DEFAULTNAMINGCONTEXT which is the domain name
DEFAULTNAMINGCONTEXT=`/usr/bin/ldapsearch -x -b "" -s base defaultnamingcontext | grep -i 'defaultnamingcontext: ' | awk '{print $2}'`
echo
echo The Domain is $DEFAULTNAMINGCONTEXT
echo -n "Do you wish to continue? [yes or no]: " 
    read IN
    case $IN in
    [Yy] | [Yy][Ee][Ss] )
        echo "Searching for objects without a uniqueDomainID"

# Search for object in the domain without the uniquedomainid expect in the Builtin and Configuration containers.
/usr/bin/ldapsearch -Y EXTERNAL -LLL -Q -b "" -s sub '(&(!(uniqueDomainID=*))(!(|(cn:dn:=Builtin)(cn:dn:=Configuration)(cn:dn:=ForeignSecurityPrincipals))))' dn | grep -v ^# | sed -e :a -e '$!N;s/\n //;ta' -e 'P;D'|sed -e'/^dn/ a\changetype: modify\nadd: uniquedomainid\nuniquedomainid: '1049076'' > /tmp/add_uniquedomainid.ldif
#  echo ""
    cat /tmp/add_uniquedomainid.ldif
 # echo ""
    echo -e "The ldif is located at /tmp/add_uniquedomainid.ldif"
    echo ""
    FSIZE=$(du -b /tmp/add_uniquedomainid.ldif |cut -f1)
        if [ $FSIZE -gt 1 ] 
        then
          echo -e "You have 10 seconds to abort the script (cntrl-c) before it adds uniquedomainid: '1049076' ..."
          sleep 10

          /usr/bin/ldapmodify -Y EXTERNAL -f /tmp/add_uniquedomainid.ldif

          echo -e "uniqueDomainid has been added"
          /usr/bin/ldapsearch -Y EXTERNAL -b "$DEFAULTNAMINGCONTEXT" -s sub uniquedomainid
          
        else
          echo All objects within the domain have a uniqueDomainID
          echo 
          
        fi
    echo -e "The ldif is located at /tmp/add_uniquedomainid.ldif"
    ;;
    [Nn] | [Nn][Oo] )
        echo "Exiting $0"
        exit 0
    ;;
    *) echo "Invalid input"
        sleep 1
        #read -p "$*" 'Press Enter key to continue'
        $0
    ;;
  esac
  
exit 0

#/usr/bin/ldapsearch -Y EXTERNAL -LLL -Q -b "$DEFAULTNAMINGCONTEXT" -s sub '(&(!(uniqueDomainID=*))(!(|(cn:dn:=Builtin)(cn:dn:=Configuration))))' dn
